# Rscript r_install.R

packages = c('testthat', 'isoband', 'ggplot2', 'pROC', 'quadprog', 'BB', 'BBmisc', 'fail', 'rlecuyer', 'snow', 'tree', 'pls', 'class', 'proxy', 'e1071', 'nnet', 'minqa', 'RcppEigen', 'MatrixModels', 'matrixStats', 'conquer', 'quantreg', 'robustbase', 'zoo', 'lmtest', 'vcd', 'snowfall', 'rpart', 'survival', 'bindr', 'plogr', 'bindrcpp', 'purrr', 'tidyselect', 'generics', 'dplyr', 'cpp11', 'tidyr', 'tmvnsim', 'mnormt', 'foreign', 'psych', 'broom', 'nloptr', 'boot', 'statmod', 'lme4', 'ucminf', 'numDeriv', 'ordinal', 'jomo', 'clipr', 'readr', 'forcats', 'haven', 'pan', 'mitml', 'mice', 'urca', 'fracdiff', 'operator.tools', 'formula.tools', 'logistf', 'akima', 'bitops', 'mixtools', 'cluster', 'gclus', 'coda', 'codetools', 'foreach', 'doMC', 'DBI', 'gam', 'gamlss.data', 'gamlss.dist', 'gamlss', 'gamlss.tr', 'hwriter', 'KernSmooth', 'xts', 'curl', 'TTR', 'quantmod', 'mvtnorm', 'pcaPP', 'SQUAREM', 'lava', 'prodlim', 'pscl', 'fastmap', 'cachem', 'memoise', 'bit64', 'blob', 'RSQLite', 'data.table', 'BatchJobs', 'sandwich', 'sfsmisc', 'spatial', 'VGAM', 'waveslim', 'xtable', 'profileModel', 'brglm', 'deSolve', 'tseriesChaos', 'tseries', 'fastICA', 'R.methodsS3', 'R.oo', 'sys', 'askpass', 'openssl', 'httr', 'cgdsr', 'R.utils', 'R.matlab', 'gridExtra', 'gbm', 'Formula', 'acepack', 'proto', 'chron', 'viridis', 'yaml', 'htmltools', 'htmlwidgets', 'knitr', 'htmlTable', 'Hmisc', 'fastcluster', 'registry', 'bibtex', 'pkgmaker', 'rngtools', 'doParallel', 'gridBase', 'irlba', 'igraph', 'GeneNet', 'ape', 'RJSONIO', 'caTools', 'gplots', 'ROCR', 'later', 'promises', 'httpuv', 'rjson', 'sourcetools', 'xml2', 'commonmark', 'jquerylib', 'rappdirs', 'fs', 'sass', 'bslib', 'shiny', 'seqinr', 'LearnBayes', 'deldir', 'gmodels', 'expm', 'raster', 'spData', 'units', 'classInt', 'vegan', 'rncl', 'XML', 'tinytex', 'rmarkdown', 'reshape', 'triebeard', 'urltools', 'httpcode', 'crul', 'bold', 'rredlist', 'rentrez', 'rotl', 'solrium', 'ritis', 'worrms', 'natserv', 'WikipediR', 'ratelimitr', 'rex', 'WikidataQueryServiceR', 'pbapply', 'WikidataR', 'wikitaxa', 'phangorn', 'uuid', 'conditionz', 'taxize', 'RNeXML', 'phylobase', 'magick', 'animation', 'bigmemory.sri', 'bigmemory', 'calibrate', 'clusterGeneration', 'dismo', 'extrafontdb', 'Rttf2pt1', 'extrafont', 'fields', 'shapefiles', 'fossil', 'phytools', 'geiger', 'shape', 'glmnet', 'crosstalk', 'miniUI', 'webshot', 'shinyjs', 'manipulateWidget', 'rgl', 'Rtsne', 'labdsv', 'stabs', 'modeltools', 'strucchange', 'TH.data', 'multcomp', 'libcoin', 'coin', 'party', 'inum', 'partykit', 'mboost', 'msm', 'nor1mix', 'np', 'polynom', 'polspline', 'rms', 'RWekajars', 'RWeka', 'slam', 'tm', 'TraMineR', 'chemometrics', 'FNN', 'ipred', 'miscTools', 'maxLik', 'gbRd', 'rbibutils', 'Rdpack', 'dfidx', 'mlogit', 'getopt', 'gsalib', 'optparse', 'labelled', 'R.cache', 'styler', 'questionr', 'klaR', 'neuRosim', 'locfit', 'GGally', 'beanplot', 'clValid', 'DiscriMiner', 'ellipse', 'leaps', 'pbkrtest', 'carData', 'maptools', 'zip', 'openxlsx', 'rematch', 'cellranger', 'readxl', 'rio', 'car', 'flashClust', 'ggrepel', 'DT', 'FactoMineR', 'flexclust', 'flexmix', 'prabclus', 'diptest', 'trimcluster', 'fpc', 'BiasedUrn', 'TeachingDemos', 'kohonen', 'base64', 'doRNG', 'nleqslv', 'Deriv', 'RGCCA', 'pheatmap', 'pvclust', 'RCircos', 'lambda.r', 'futile.options', 'futile.logger', 'VennDiagram', 'xlsxjars', 'xlsx', 'uroot', 'forecast', 'fma', 'expsmooth', 'fpp', 'tensor', 'polyclip', 'goftest', 'spatstat.utils', 'spatstat.data', 'spatstat.geom', 'spatstat.sparse', 'spatstat.core', 'spatstat.linnet', 'spatstat', 'pracma', 'RCurl', 'bio3d', 'AUC', 'interpretR', 'cvAUC', 'SuperLearner', 'mediation', 'ModelMetrics', 'CVST', 'DRR', 'dimRed', 'lubridate', 'ddalpha', 'gower', 'RcppRoll', 'recipes', 'caret', 'adabag', 'parallelMap', 'ParamHelpers', 'ggvis', 'mlr', 'unbalanced', 'RSNNS', 'abc.data', 'abc', 'lhs', 'tensorA', 'EasyABC', 'whisker', 'roxygen2', 'git2r', 'rversions', 'xopen', 'sessioninfo', 'rcmdcheck', 'remotes', 'clisymbols', 'ini', 'gitcreds', 'gh', 'credentials', 'gert', 'usethis', 'covr', 'devtools', 'Rook', 'Cairo', 'RMTstat', 'Lmoments', 'distillery', 'extRemes', 'tkrplot', 'misc3d', 'multicool', 'plot3D', 'plot3Drgl', 'OceanView', 'ks', 'logcondens', 'Iso', 'penalized', 'clusterRepro', 'data.tree', 'influenceR', 'visNetwork', 'downloader', 'DiagrammeR', 'randomForestSRC', 'sm', 'pbivnorm', 'lavaan', 'matrixcalc', 'arm', 'mi', 'servr', 'rgexf', 'sem', 'network', 'rle', 'statnet.common', 'sna', 'glasso', 'huge', 'd3Network', 'BDgraph', 'graphlayouts', 'tweenr', 'ggforce', 'tidygraph', 'ggraph', 'qgraph', 'diveRsity', 'doSNOW', 'geepack', 'pim', 'minpack.lm', 'rootSolve', 'diagram', 'FME', 'bmp', 'tiff', 'readbitmap', 'imager', 'signal', 'tuneR', 'pastecs', 'audio', 'fftw', 'seewave', 'gsw', 'sf', 'oce', 'ineq', 'soundecology', 'memuse', 'pinfsc50', 'vcfR', 'glmmML', 'cowplot', 'tsne', 'sn', 'tclust', 'ranger', 'hexbin', 'pryr', 'moments', 'laeken', 'VIM', 'smoother', 'dynamicTreeCut', 'beeswarm', 'vipor', 'ggbeeswarm', 'shinydashboard', 'rrcov', 'WriteXLS', 'bst', 'pamr', 'WeightSVM', 'mpath', 'timereg', 'peperr', 'heatmap3', 'GlobalOptions', 'circlize', 'GetoptLong', 'dendextend', 'RInside', 'limSolve', 'dbplyr', 'modelr', 'debugme', 'reprex', 'selectr', 'rvest', 'dtplyr', 'gargle', 'googledrive', 'ids', 'googlesheets4', 'tidyverse', 'R.rsp', 'listenv', 'globals', 'parallelly', 'future', 'gdistance', 'vioplot', 'emulator', 'gmm', 'tmvtnorm', 'IDPmisc', 'gap', 'qrnn', 'TMB', 'glmmTMB', 'gmp', 'ROI', 'Rglpk', 'ROI.plugin.glpk', 'spaMM', 'qgam', 'DHARMa', 'mvnfast', 'bridgesampling', 'BayesianTools', 'gomms', 'feather', 'dummies', 'SimSeq', 'PoissonSeq', 'aod', 'svd', 'Rssa', 'RUnit', 'DistributionUtils', 'gapfill', 'gee', 'Matching', 'MatchIt', 'RItools', 'mitools', 'survey', 'optmatch', 'SPAtest', 'SKAT', 'GillespieSSA', 'startupmsg', 'distr', 'distrEx', 'KODAMA', 'locfdr', 'ica', 'dtw', 'ggridges', 'TFisher', 'lsei', 'npsurv', 'fitdistrplus', 'reticulate', 'hdf5r', 'DTRreg', 'pulsar', 'bayesm', 'gsl', 'energy', 'compositions', 'clustree', 'plotly', 'tweedie', 'RcppGSL', 'mvabund', 'fishMod', 'gllvm', 'grpreg', 'trust', 'ergm', 'networkDynamic', 'tergm', 'ergm.count', 'tsna', 'statnet', 'aggregation', 'ComICS', 'dtangle', 'mcmc', 'MCMCpack', 'shinythemes', 'csSAM', 'bridgedist', 'asnipe', 'oddsratio', 'mltools', 'h2o', 'mlegp', 'itertools', 'missForest', 'bartMachineJARs', 'bartMachine', 'PresenceAbsence', 'GUTS', 'GenSA', 'parsedate', 'circular', 'cobs', 'resample', 'MIIVsem', 'medflex', 'Rserve', 'spls', 'Boruta', 'dr', 'CovSel', 'tmle', 'ctmle', 'inline', 'BMA', 'BCEE', 'bacr', 'clue', 'bdsmatrix', 'fftwtools', 'imagerExtra', 'MALDIquant', 'threejs', 'LaplacesDemon', 'sampling', 'lda', 'jiebaRD', 'jiebaR', 'hdm', 'abe', 'SignifReg', 'bbmle', 'emdbook', 'SOAR', 'terra', 'rasterVis', 'tictoc', 'ISOcodes', 'stopwords', 'janeaustenr', 'SnowballC', 'tokenizers', 'hunspell', 'topicmodels', 'tidytext', 'splitstackshape', 'grImport2', 'preseqR', 'idr', 'entropy', 'kedd', 'HiddenMarkov', 'lmerTest', 'loo', 'RcppParallel', 'StanHeaders', 'Rborist', 'VSURF', 'mRMRe', 'dHSIC', 'ggsci', 'ggsignif', 'corrplot', 'rstatix', 'ggpubr', 'yaImpute', 'intrinsicDimension', 'patchwork', 'leiden', 'future.apply', 'sctransform', 'packrat', 'colourpicker', 'ggExtra', 'findpython', 'argparse', 'intergraph', 'ggnetwork', 'qqman', 'rstantools', 'bayesplot', 'dygraphs', 'rsconnect', 'optimx', 'gamm4', 'projpred', 'drgee', 'stdReg', 'mcmcse', 'copCAR', 'batchmeans', 'ngspatial', 'BIGL', 'betareg', 'unmarked', 'maxlike', 'coxme', 'AICcmodavg', 'pacman', 'spaa', 'maxnet', 'ENMeval', 'plotmo', 'earth', 'mda', 'biomod2', 'poLCA', 'PermAlgo', 'coxed', 'testit', 'NISTunits', 'celestial', 'fasterize', 'RPMM', 'wordcloud', 'JADE', 'awsMethods', 'aws', 'ruv', 'mhsmm', 'dbarts', 'proftools', 'NCmisc', 'reader', 'gnumeric', 'tcltk2', 'readODS', 'nortest', 'EnvStats', 'outliers', 'elementR', 'gWidgets2', 'gWidgets2tcltk', 'mgsub', 'ie2misc', 'assertive.base', 'assertive.properties', 'assertive.types', 'assertive.numbers', 'assertive.strings', 'assertive.datetimes', 'assertive.files', 'assertive.sets', 'assertive.matrices', 'assertive.models', 'assertive.data', 'assertive.data.uk', 'assertive.data.us', 'assertive.reflection', 'assertive.code', 'assertive', 'rdrop2', 'Exact', 'lmom', 'gld', 'DescTools', 'orthopolynom', 'gaussquad', 'nlsem', 'tableone', 'jstable', 'RCAL', 'stargazer', 'sensemakr', 'CompQuadForm', 'nonnest2', 'mathjaxr', 'metafor', 'fmri', 'AnalyzeFMRI', 'linkcomm', 'rnetcarto', 'DEoptim', 'optextras', 'setRNG', 'Rvmmin', 'Rcgmin', 'optimr', 'DMCfun', 'miceadds', 'visdat', 'UpSetR', 'norm', 'naniar', 'stringdist', 'image.binarization', 'lslx', 'truncnorm', 'Rsolnp', 'regsem', 'semPLS', 'GxEScanR', 'alabama', 'polycor', 'progressr', 'multipol', 'symmoments', 'cSEM', 'cubelyr', 'broom.mixed', 'DiceKriging', 'grf', 'xgboost', 'twang', 'neuralnet', 'PCAmatchR', 'origami', 'hal9001', 'cobalt', 'CBPS', 'SBdecomp', 'naturalsort', 'lwgeom', 'finalfit', 'broom.helpers', 'gt', 'gtsummary')

## Now load or install&load all
package.check <- lapply(
  packages,
  FUN = function(x) {
    if (!require(x, character.only = TRUE)) {
      install.packages(x, repos='https://www.freestatistics.org/cran/')
      library(x, character.only = TRUE)
    }
  }
)
